/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2024 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "SharedPreferencesForWebProcess.h"

#include "WebPreferences.h"

namespace WebKit {

SharedPreferencesForWebProcess sharedPreferencesForWebProcess(const WebPreferences& preferences)
{
    SharedPreferencesForWebProcess sharedPreferences;
        sharedPreferences.allowTestOnlyIPC = preferences.allowTestOnlyIPC();
        sharedPreferences.usesSingleWebProcess = preferences.usesSingleWebProcess();
#if ENABLE(RE_DYNAMIC_CONTENT_SCALING)
        sharedPreferences.useCGDisplayListsForDOMRendering = preferences.useCGDisplayListsForDOMRendering();
#endif
#if ENABLE(GPU_PROCESS)
        sharedPreferences.useGPUProcessForDOMRenderingEnabled = preferences.useGPUProcessForDOMRenderingEnabled();
#endif
#if ENABLE(GPU_PROCESS) && ENABLE(WEBGL)
        sharedPreferences.useGPUProcessForWebGLEnabled = preferences.useGPUProcessForWebGLEnabled();
#endif
        sharedPreferences.lockdownFontParserEnabled = preferences.lockdownFontParserEnabled();
        sharedPreferences.shapeDetection = preferences.shapeDetection();
        sharedPreferences.webGLEnabled = preferences.webGLEnabled();
        sharedPreferences.webGPUEnabled = preferences.webGPUEnabled();
        sharedPreferences.webTransportEnabled = preferences.webTransportEnabled();
#if ENABLE(WEBXR)
        sharedPreferences.webXREnabled = preferences.webXREnabled();
#endif
    return sharedPreferences;
}

bool updateSharedPreferencesForWebProcess(SharedPreferencesForWebProcess& sharedPreferences, const WebPreferences& preferences)
{
    bool didChange = false;
    if (preferences.allowTestOnlyIPC() && !sharedPreferences.allowTestOnlyIPC) {
        sharedPreferences.allowTestOnlyIPC = true;
        didChange = true;
    }
    if (preferences.usesSingleWebProcess() && !sharedPreferences.usesSingleWebProcess) {
        sharedPreferences.usesSingleWebProcess = true;
        didChange = true;
    }
#if ENABLE(RE_DYNAMIC_CONTENT_SCALING)
    if (preferences.useCGDisplayListsForDOMRendering() && !sharedPreferences.useCGDisplayListsForDOMRendering) {
        sharedPreferences.useCGDisplayListsForDOMRendering = true;
        didChange = true;
    }
#endif
#if ENABLE(GPU_PROCESS)
    if (preferences.useGPUProcessForDOMRenderingEnabled() && !sharedPreferences.useGPUProcessForDOMRenderingEnabled) {
        sharedPreferences.useGPUProcessForDOMRenderingEnabled = true;
        didChange = true;
    }
#endif
#if ENABLE(GPU_PROCESS) && ENABLE(WEBGL)
    if (preferences.useGPUProcessForWebGLEnabled() && !sharedPreferences.useGPUProcessForWebGLEnabled) {
        sharedPreferences.useGPUProcessForWebGLEnabled = true;
        didChange = true;
    }
#endif
    if (preferences.lockdownFontParserEnabled() && !sharedPreferences.lockdownFontParserEnabled) {
        sharedPreferences.lockdownFontParserEnabled = true;
        didChange = true;
    }
    if (preferences.shapeDetection() && !sharedPreferences.shapeDetection) {
        sharedPreferences.shapeDetection = true;
        didChange = true;
    }
    if (preferences.webGLEnabled() && !sharedPreferences.webGLEnabled) {
        sharedPreferences.webGLEnabled = true;
        didChange = true;
    }
    if (preferences.webGPUEnabled() && !sharedPreferences.webGPUEnabled) {
        sharedPreferences.webGPUEnabled = true;
        didChange = true;
    }
    if (preferences.webTransportEnabled() && !sharedPreferences.webTransportEnabled) {
        sharedPreferences.webTransportEnabled = true;
        didChange = true;
    }
#if ENABLE(WEBXR)
    if (preferences.webXREnabled() && !sharedPreferences.webXREnabled) {
        sharedPreferences.webXREnabled = true;
        didChange = true;
    }
#endif
    return didChange;
}

} // namespace WebKit
